/*
 * Interface of the interprocess communication
 *
 * HISTORY
 * Date         Author  Remarks
 * 1999-02-21   hjb     First implementation
 */

#ifndef COMM_H
#define COMM_H

#include "netchaos.h"

extern void CommSelect(int argc, char** argv);
extern void CommInitMaster(int argc, char** argv, int& nservers, int& rank);
extern void CommRecvCancel();
extern void CommRecvNew();
extern void CommRecvNext();
extern Boolean CommRecvTestMaster();
extern Boolean CommRecvTestSlave(int imageno);
extern int CommRecvSource();
extern void CommSend(int server);
extern Boolean CommInitSlave();
extern void CommWaitSlave();
extern void CommRecvNextSlave();
extern int CommGetResultSize(Image *pic);
extern Boolean CommAllocBuffer(int size);
extern SharedInfo *CommGetCommand();
extern DOUBLE *CommGetBuffer();
extern void CommFreeBuffer();
extern void CommSendResponse(DOUBLE response);
extern void CommSendResult();
extern void CommEndMaster();
extern void CommEndSlave();

#endif /* COMM_H */
