#ifndef DIALOG_H
#define DIALOG_H

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>


typedef struct
{
    char        *title;
    char        *directory;
    char        *defaultName;
    int         mode;                           /* access mode (R_OK, W_OK) */
    Boolean     (*function)(char *filename);
} FileRequest;


extern Boolean  newSize;

extern Widget   fileSelectBox;

extern void     AboutInit(Widget parent);
extern void     FileSelectInit(Widget parent);
extern void     MessageInit(Widget parent);
extern void     OptionInit(Widget parent);
extern void     QuitInit(Widget parent);
extern void     SizeInit(Widget parent);

extern void     AboutPopup(int x, int y);
extern void     FileSelectPopup(int x, int y, FileRequest *request);
extern void     Message(char *format, ...);
extern void     OptionPopup(int x, int y);
extern void     QuitPopup(int x, int y);
extern void     SizePopup(int x, int y);
extern void     NewSize();

#endif /* DIALOG_H */
