/*
 * Implementation of a message box
 *
 *  HISTORY
 *  Date        Author  Remarks
 *  1996-10-17  hjb     Reformatted
 */

#include <stdarg.h>
#include <stdio.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

#include <X11/Xaw3d/Dialog.h>


static Widget   messageBox;
static Widget   messageDialog;


/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

static void MessageCB(Widget w, XtPointer clientData, XtPointer callData)
{
    XtPopdown(messageBox);
} /* MessageCB */




/*---------------------------------------------------------------------------
 *
 * The format string must make sure that no more than 1024 characters are
 * written.
 *
 *---------------------------------------------------------------------------*/

void Message(char *format, ...)
{
    va_list     args;
    char        s[1024];
    int         x, y;

    va_start(args, format);
    x = y = 100;

    vsnprintf(s, sizeof s, format, args);
    va_end(args);

    XtVaSetValues(messageDialog, XtNlabel, s, 0);
    XtVaSetValues(messageBox, XtNx, x, XtNy, y, 0);
    XtPopup(messageBox, XtGrabExclusive);

} /* Message */




/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

void MessageInit(Widget parent)
{
    messageBox = XtVaCreatePopupShell("messagebox", topLevelShellWidgetClass,
        parent, 0);
    messageDialog = XtVaCreateManagedWidget("messagedialog",
        dialogWidgetClass, messageBox, 0);

    XawDialogAddButton(messageDialog, "messagebutton", MessageCB, 0);

} /* MessageInit */
