#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

#include <X11/Xaw3d/Box.h>
#include <X11/Xaw3d/Command.h>
#include <X11/Xaw3d/Label.h>
#include <X11/Xaw3d/Toggle.h>

#include "EditField.h"
#include "netchaos.h"


static Widget       optionBox;
static EditField    optionField[10];
static Widget       optionToggle1;
static Widget       optionToggle2;




/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

static void OptionCB(Widget w, XtPointer clientData, XtPointer callData)
{
    Image       newpic;
    int         changed;
    Boolean     error = False;
    char        *s;

    XtPopdown(optionBox);
    if ((Boolean) clientData)
    {
        /* Fetch the new data and look for changes */
        newpic = pic;
        error = error || !optionField[0].GetValue(XtNstring, &newpic.re1);
        error = error || !optionField[1].GetValue(XtNstring, &newpic.re2);
        error = error || !optionField[2].GetValue(XtNstring, &newpic.im1);
        error = error || !optionField[3].GetValue(XtNstring, &newpic.im2);
        error = error || !optionField[4].GetValue(XtNstring, &newpic.reP);
        error = error || !optionField[5].GetValue(XtNstring, &newpic.imP);
        error = error || !optionField[6].GetValue(XtNstring, &newpic.reJ);
        error = error || !optionField[7].GetValue(XtNstring, &newpic.imJ);
        s = (char *) XawToggleGetCurrent(optionToggle1);
        if (s != 0)
            newpic.julia = (s[strlen(s) - 1] == '2');

        changed = memcmp(&newpic, &pic, sizeof(pic));
        error = error || !optionField[8].GetValue(XtNstring, &newpic.maxc);
        error = error || !optionField[9].GetValue(XtNstring, &newpic.bailout);

        if (!error && memcmp(&newpic, &pic, sizeof(pic)) != 0)
        {
            pic = newpic;
            if (changed)
                SaveToStack();
            newPicture = True;
        }
    }

} /* OptionCB */




/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

void OptionPopup(int x, int y)
{
    XtVaSetValues(optionBox, XtNx, x, XtNy, y, 0);

    optionField[0].SetValue(XtNstring, &pic.re1);
    optionField[1].SetValue(XtNstring, &pic.re2);
    optionField[2].SetValue(XtNstring, &pic.im1);
    optionField[3].SetValue(XtNstring, &pic.im2);
    optionField[4].SetValue(XtNstring, &pic.reP);
    optionField[5].SetValue(XtNstring, &pic.imP);
    optionField[6].SetValue(XtNstring, &pic.reJ);
    optionField[7].SetValue(XtNstring, &pic.imJ);
    optionField[8].SetValue(XtNstring, &pic.maxc);
    optionField[9].SetValue(XtNstring, &pic.bailout);

    XtVaSetValues(optionToggle1, XtNstate, pic.julia ? False : True, 0);
    XtVaSetValues(optionToggle2, XtNstate, pic.julia ? True : False, 0);

    XtPopup(optionBox, XtGrabExclusive);

} /* OptionPopup */




/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

void OptionInit(Widget parent)
{
    int         i;
    Widget      optionContainer;
    Widget      optionToggleBox;
    Widget      optionButtonBox;
    Widget      optionButton1;
    Widget      optionButton2;

    optionBox = XtVaCreatePopupShell("optionbox", topLevelShellWidgetClass,
        parent, 0);
    optionContainer = XtVaCreateManagedWidget("optioncontainer", boxWidgetClass,
        optionBox, 0);

    for (i = 0; i < 8; i++)
        optionField[i].Create(optionContainer, i + 1, "option", EDT_DOUBLE);

    optionField[8].Create(optionContainer, 9, "option", EDT_ULONG);
    optionField[9].Create(optionContainer, 10, "option", EDT_DOUBLE);

    optionToggleBox = XtVaCreateManagedWidget("optiontogglebox", boxWidgetClass,
        optionContainer, 0);
    optionToggle1 = XtVaCreateManagedWidget("optiontoggle1", toggleWidgetClass,
        optionToggleBox, 0);
    optionToggle2 = XtVaCreateManagedWidget("optiontoggle2", toggleWidgetClass,
        optionToggleBox, 0);

    XtVaSetValues(optionToggle1, XtNradioGroup, optionToggle2, 0);
    XtVaSetValues(optionToggle2, XtNradioGroup, optionToggle1, 0);

    optionButtonBox = XtVaCreateManagedWidget("optionbuttonbox", boxWidgetClass,
        optionContainer, 0);
    optionButton1 = XtVaCreateManagedWidget("optionbutton1", commandWidgetClass,
        optionButtonBox, 0);
    optionButton2 = XtVaCreateManagedWidget("optionbutton2", commandWidgetClass,
        optionButtonBox, 0);

    XtAddCallback(optionButton1, XtNcallback, OptionCB, (caddr_t) True);
    XtAddCallback (optionButton2, XtNcallback, OptionCB, (caddr_t) False);

} /* OptionInit */
