#include <Intrinsic.h>
#include <StringDefs.h>
#include <Shell.h>

#include <Xaw3d/Box.h>
#include <Xaw3d/Command.h>

#include "EditField.h"
#include "dialog.h"
#include "mandel.h"


Widget			fileSelectBox;
static EditField	fileSelectName;
static FileRequest	fileRequest;




/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

static void FileSelectCB (Widget w, XtPointer clientData, XtPointer callData)
{
  Boolean	error;
  Boolean	finished;
  char		s [200];
  char		filename [200];

  /* finished becomes True if the cancel button is pressed. */
  finished = (Boolean) clientData;
  if (!finished)
  {
    error = !fileSelectName.GetValue (XtNstring, s);
    strcpy (filename, frakDir);
    strcat (filename, s);
    if (!error)
    {
      if (fileRequest.function (filename))
        finished = True;
      else
      {
	if (fileRequest.mode == W_OK)
          Message ("Could not write file %s\n", filename);
	else
          Message ("Could not read file %s\n", filename);
      }
    }
    else
      Message ("No such file %s\n", filename);
  }

  if (finished)
    XtPopdown (fileSelectBox);
} /* FileSelectCB */




/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

void FileSelectPopup (int x, int y, FileRequest *request)
{
  fileRequest = *request;
  fileSelectName.SetValue (XtNstring, request->defaultName);
  XtVaSetValues (fileSelectBox, XtNx, x, XtNy, y, XtNtitle, request->title, 0);
  XtPopup (fileSelectBox, XtGrabExclusive);
} /* FileSelectPopup */




/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

void FileSelectInit (Widget parent)
{
  Widget        fileSelectContainer;
  Widget        fileSelectButtonBox;
  Widget        fileSelectButton1;
  Widget        fileSelectButton2;

  fileSelectBox = XtVaCreatePopupShell ("fileSelectbox",
    topLevelShellWidgetClass, parent, 0);
  fileSelectContainer = XtVaCreateManagedWidget ("fileSelectcontainer",
    boxWidgetClass, fileSelectBox, 0);
  fileSelectName.Create (fileSelectContainer, 1, "fileselect", EDT_STRING);
  fileSelectButtonBox = XtVaCreateManagedWidget ("fileselectbuttonbox",
    boxWidgetClass, fileSelectContainer, XtNorientation, XtorientHorizontal, 0);
  fileSelectButton1 = XtVaCreateManagedWidget ("fileselectbutton1",
    commandWidgetClass, fileSelectButtonBox, 0);
  fileSelectButton2 = XtVaCreateManagedWidget ("fileselectbutton2",
    commandWidgetClass, fileSelectButtonBox, 0);
  XtAddCallback (fileSelectButton1, XtNcallback, FileSelectCB, (caddr_t) False);
  XtAddCallback (fileSelectButton2, XtNcallback, FileSelectCB, (caddr_t) True);
} /* FileSelectInit */

