#include "mdefs.h"
#include "mandel.h"


LONG iterations;


LONG Iterate (Image *image)
{
  DOUBLE	qre, qim;
  DOUBLE	zre, zim;
  DOUBLE	cre, cim;
  LONG		count = 0;

  zre = image->reC;
  zim = image->imC;

  if (image->julia)
  {
    cre = image->reJ;
    cim = image->imJ;
  }
  else
  {
    cre = image->reC;
    cim = image->imC;
  }

  cre += image->reP;
  cim += image->imP;

  qre = zre * zre;
  qim = zim * zim;

  do
  {
    count++;
    zim = 2 * zre * zim + cim;
    zre = qre - qim + cre;
    qre = zre * zre;
    qim = zim * zim;
  } while (count < image->maxc && qre + qim < image->bailout);

  iterations += count;
  return count;
};

