#include <stdarg.h>
#include <stdio.h>

#include <Intrinsic.h>
#include <StringDefs.h>
#include <Shell.h>

#include <Xaw3d/Dialog.h>


static Widget		messageBox;
static Widget		messageDialog;


/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

static void MessageCB (Widget w, XtPointer clientData, XtPointer callData)
{
  XtPopdown (messageBox);
} /* MessageCB */




/*---------------------------------------------------------------------------
 *
 * The format string must make sure that no more than 1000 characters are
 * written.
 *
 *---------------------------------------------------------------------------*/

void Message (char *format, ...)
{
  va_list	args;
  char		s [1000];
  int		x, y;

  va_start (args, format);
  x = y = 100;
  vsprintf (s, format, args);
  XtVaSetValues (messageDialog, XtNlabel, s, 0);
  XtVaSetValues (messageBox, XtNx, x, XtNy, y, 0);
  XtPopup (messageBox, XtGrabExclusive);
} /* Message */




/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

void MessageInit (Widget parent)
{
  messageBox = XtVaCreatePopupShell ("messagebox", topLevelShellWidgetClass,
    parent, 0);
  messageDialog = XtVaCreateManagedWidget ("messagedialog",
    dialogWidgetClass, messageBox, 0);
  XawDialogAddButton (messageDialog, "messagebutton", MessageCB, 0);
} /* MessageInit */

