#include <Intrinsic.h>
#include <StringDefs.h>
#include <Shell.h>

#include <Xaw3d/Box.h>
#include <Xaw3d/Command.h>
#include <Xaw3d/Label.h>

#include "mandel.h"


Widget quitBox;




/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

static void QuitCB (Widget w, XtPointer clientData, XtPointer callData)
{
  XtPopdown (quitBox);
  if ((Boolean) clientData)
    Exit (0);
} /* QuitCB */




/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

void QuitPopup (int x, int y)
{
  XtVaSetValues (quitBox, XtNx, x, XtNy, y, 0);
  XtPopup (quitBox, XtGrabExclusive);
} /* QuitPopup */




/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

void QuitInit (Widget parent)
{
  Widget        quitContainer;
  Widget        quitLabel;
  Widget        quitButtonBox;
  Widget        quitButton1;
  Widget        quitButton2;

  quitBox = XtVaCreatePopupShell ("quitbox", wmShellWidgetClass, parent, 0);
  quitContainer = XtVaCreateManagedWidget ("quitcontainer", boxWidgetClass,
    quitBox, 0);
  quitLabel = XtVaCreateManagedWidget ("quitlabel", labelWidgetClass,
    quitContainer, 0);
  quitButtonBox = XtVaCreateManagedWidget ("quitbuttonbox", boxWidgetClass,
    quitContainer, 0);
  quitButton1 = XtVaCreateManagedWidget ("quitbutton1", commandWidgetClass,
    quitButtonBox, 0);
  quitButton2 = XtVaCreateManagedWidget ("quitbutton2", commandWidgetClass,
    quitButtonBox, 0);
  XtAddCallback (quitButton1, XtNcallback, QuitCB, (caddr_t) True);
  XtAddCallback (quitButton2, XtNcallback, QuitCB, (caddr_t) False);
} /* QuitInit */

