#include <signal.h>
#include <stdarg.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#include "mandel.h"


int debugLevel = 8;




/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

void Debug (int level, char *format, ...)
{
  va_list args;

  va_start (args, format);
  if (level <= debugLevel)
    vprintf (format, args);
} /* Debug */




/*---------------------------------------------------------------------------
 *
 * Returns True if select () was interrupted.
 *
 *---------------------------------------------------------------------------*/

void WaitForAck (void)
{
  struct timeval tv;

  tv.tv_sec = 10;       /* Under heavy load, a long time could elapse */
  tv.tv_usec = 0;
  if (select (0, 0, 0, 0, &tv) != -1)
    /* There's not much to do: the program should only exit when
    killed by its parent. In fact, it is necessary to wait
    forever, e.g. for the start command. */
    ;
  return;
} /* WaitForAck */




/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

void NewPicture (void)
{
  /* May be set to True even when no valid data are in the structure. */
  sharedInfo->start = True;
  kill (child, SIGHANDSHAKE);
  while (sharedInfo->startACK == False)
  WaitForAck ();
  memcpy (&sharedInfo->pic, &pic, sizeof (pic));
  sharedInfo->readyACK = False;
  sharedInfo->start = False;
  kill (child, SIGHANDSHAKE);
  while (sharedInfo->startACK == True)
  WaitForAck ();
} /* NewPicture */

