/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
 *                                                                           *
 *                                                                           *
 *+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


#include <stdlib.h>                 /* strtoul         */
#include <stdio.h>
#include <string.h>
/*#include <signal.h>                 /* signal          */
#include <Xlib.h>
#include "mandel.h"                 /* export-def.     */
#include "mdefs.h"                  /* portabilitaet   */


typedef struct
{
  DOUBLE	re1;
  DOUBLE	re2;
  DOUBLE	im1;
  DOUBLE	im2;
  DOUBLE	reP;			/* re perturbation */
  DOUBLE	imP;			/* im perturbation */
  DOUBLE	bailout;		/* bailout value */
  int		width;			/* width in pixels */
  int		height;			/* height in pixels */
  LONG		maxc;			/* max number of iterations */
  BOOL		julia;			/* true if julia-set */
} Image;


Image pic;




/*---------------------------------------------------------------------------
 *
 *
 *---------------------------------------------------------------------------*/

int main (int argc, char **argv)
{
  int		i;
  Display	*display;
  Window	root, rootParent;
  Window	*children;
  unsigned	numChildren;
  Window	p, mine;
  int		x, y;
  GC		gc;
  XGCValues	val;
  unsigned	width, height, bw, depth;

  mine = (Window) strtoul (argv [1], 0, 0);
  printf ("%x\n", (unsigned) mine);

  display = XOpenDisplay (0);
  if (display == 0)
  {
    fprintf (stderr, "Unable to open display\n");
    return 1;
  }

  XQueryTree (display, DefaultRootWindow (display), &root, &rootParent,
    &children, &numChildren);

  for (i = 0; i < numChildren; i++)
  {
    p = children [i];
    XGetGeometry (display, p, &root, &x, &y, &width, &height, &bw, &depth);
    if (p == mine)
      printf (" das isses ");
    printf ("%x (%d,%d) %dx%dx%d\n", (unsigned) p, x, y, width, height, depth);
  }
  XFree (children);

  val.foreground = WhitePixel (display, 0);
  gc = XCreateGC (display, mine, GCForeground, &val);
  XDrawLine (display, mine, gc, 5, 1, 113, 45);
  XFreeGC (display, gc);
  XCloseDisplay (display);
  return 0;

} /* main */

