#!/usr/local/bin/wishx -f

# if 80 bit float is supported, 23 is what we want
set tcl_precision 17

# default values for the window
set width 320
set height 200
set sincrement 25

# default values for the image
# Width and height are independent of the complex coordinates, so you can
# create distorted images.
set picW 640
set picH 480
set picRe1 -2.5
set picRe2 1.5
set picIm1 1.5
set picIm2 -1.5
# perturbation
set picReP 0
set picImP 0

canvas .plane -background black -width $width -height $height \
	-scrollregion [ concat 0 0 [ expr $picW - 1 ] [ expr $picH - 1 ] ] \
	-scrollincrement $sincrement \
	-xscrollcommand ".scrollx set" -yscrollcommand ".scrolly set"

scrollbar .scrollx -orient horizontal -command ".plane xview"
scrollbar .scrolly -orient vertical -command ".plane yview"

pack .scrolly -side right -fill y
pack .scrollx -side bottom -fill x
pack .plane

wm title . "Mandel"
bind . q "End ()"
update
set windowID [winfo id .plane]
puts $windowID

proc End () {
  tk_dialog .done "That was it" "And now..." "" 0 "Done"
  exit
}

