/*
 * Declarations for util.c
 *
 *  HISTORY
 *  Date        Author  Remarks
 *  1999-02-19  hjb     First implementation
 *  1999-02-21  hjb     Moved WaitForAck to comm.c, added xalloc etc.
 *  1999-03-10  hjb     New function GetTime
 */

#ifndef UTIL_H
#define UTIL_H

#define DEBUGCODE(level, n) (level) + ((n) << 8)

#define DEBUG_GEN(level) DEBUGCODE(level, 0)
#define DEBUG_CMD(level) DEBUGCODE(level, 1)
#define DEBUG_PERF(level) DEBUGCODE(level, 2)
#define DEBUG_COMM(level) DEBUGCODE(level, 3)

extern void Debug(int level, char *format, ...);
extern int  GetDebugLevel();
extern void SetDebugLevel(int level);
extern void SetDebugFile(const char *filename);

extern void* xmalloc(size_t size);
extern void* xrealloc(void *p, size_t size);
extern void* xcalloc(size_t size);
extern void  xfree(void *p);

extern void GetTime(struct timeval& tv);

#endif /* UTIL_H */
